


#include "stdafx.h"
#include <strsafe.h>
#include "gesture.h"
#include <wchar.h>
#include <cmath>

static enum mouvement savMov[12] = { faceCam };
static int savPos = 1;

const float SwipeMinimalLength = 0.2f;
const float SwipeMaximalHeight = 0.3f;
const int SwipeMininalDuration = 250;
const int SwipeMaximalDuration = 2000;

const float maxRangeQuartTour = 0.1f;
const int QuartTourMininalDuration = 800;

const float HancheMinimalLengthH = 0.003f;
const float HancheMaximalLengthH = 0.5f;
const float HancheMinimalLengthZ = 0.001f;
const float HancheMaximalLengthZ = 1.0f;

const int HancheMininalDuration = 200;
const int HancheMaximalDuration = 2000;



void addCombinaison(enum mouvement mov)
{
	savMov[savPos % 12] = mov;
	savPos++;
}


void profondeur(struct cnx *cnx, float headz)
{
	
	// 0 si on est sur la camra
	// plus on est loin plus la valeure est grande
	// impression que c'est en metre
	static char oldvalue = 125;

	char msg[3];
	
	msg[0] = '1';

	msg[1] = (char) ((headz) / 3 * 255);
	if (msg[1] > 255)
		msg[1] = 255;
	msg[1] = 255 - msg[1];
	if (msg[1] == oldvalue)
		return;
	
	oldvalue = msg[1];
	
	msg[2] = '\0';

	//wchar_t test[255] = { '\0' };
	//swprintf(test, L"head z : %f\n", headz);
	//OutputDebugString(test);
	
	setMessageUDP (cnx, msg);

}


void swipeRight(struct cnx *cnx, struct pos *pos)
{
	static struct pos oldvalue = { 0 };
	
	if (oldvalue.z == 0)
	{
		oldvalue = *pos;
		return;
	}

	if (pos->time - oldvalue.time > SwipeMininalDuration)
	{
		oldvalue = *pos;
		return;
	}

	 if ((std::abs(pos->y - oldvalue.y) < SwipeMaximalHeight) // Height
                && (pos->x - oldvalue.x > -0.01f) // Progression to right
                && (std::abs(pos->x - oldvalue.x) > SwipeMinimalLength)  // Length
				&& (pos->time - oldvalue.time < SwipeMaximalDuration)) // Duration
            {
				char msg[3];
				msg[0] = '2';
				msg[1] = '0';
				msg[2] = '\0';
				OutputDebugString(L"SwipeRight\n");
				addCombinaison(swipeDroite);
				setMessageUDP (cnx, msg);
				oldvalue = *pos;
    		}

}


void swipeLeft(struct cnx *cnx, struct pos *pos)
{
	static struct pos oldvalue = { 0 };
	
	if (oldvalue.z == 0)
	{
		oldvalue = *pos;
		return;
	}
	if (pos->time - oldvalue.time > SwipeMininalDuration)
	{
		oldvalue = *pos;
		return;
	}

	 if ((std::abs(pos->x - oldvalue.x) < SwipeMaximalHeight) // Height
                && (pos->x - oldvalue.x < 0.01f) // Progression to left
                && (std::abs(pos->x - oldvalue.x) > SwipeMinimalLength)  // Length
				&& (pos->time - oldvalue.time < SwipeMaximalDuration)) // Duration
            {
				char msg[3];
				msg[0] = '3';
				msg[1] = '0';
				msg[2] = '\0';
				OutputDebugString(L"SwipeLeft\n");
				addCombinaison(swipeDroite);
				oldvalue = *pos;
				setMessageUDP (cnx, msg);
            }
}


void posture(struct cnx *cnx, struct pos *hancheDroite, struct pos *hancheGauche)
{
	char msg[3];
	static struct pos oldvalue = { 0 };
	//wchar_t test[255] = { '\0' };
	//swprintf(test, L"oldvalue : %i, new value: %i. Diff:%i, max range:%i\n", oldvalue.time, hancheGauche->time,hancheGauche->time - oldvalue.time, QuartTourMininalDuration);
	//OutputDebugString(test);
	if (oldvalue.z == 0)
	{
		
		oldvalue = *hancheDroite;
		return;
	}


	if ((hancheGauche->time - oldvalue.time) < QuartTourMininalDuration)
	{
		return;
	}
	

	msg[1] = '0';
	msg[2] = '\0';
		
	 if (std::abs(hancheDroite->x - hancheGauche->x) < maxRangeQuartTour) 
	 {
		 if (hancheDroite->z < hancheGauche->z)
		 {
			 // quart tour droite
			 
			 if (savMov[(savPos - 1) % 12] == quartTourDroite)
				 return;

			
			oldvalue = *hancheGauche;
			 addCombinaison(quartTourDroite);
			 msg[0] = '4';
			OutputDebugString(L"quartTourDroite\n");
			setMessageUDP (cnx, msg);
		 }
		 else
		 {
			 if (savMov[(savPos - 1) % 12] == quartTourGauche)
				 return;
			 addCombinaison(quartTourGauche);
			 msg[0] = '5';
			OutputDebugString(L"quartTourGauche\n");
			setMessageUDP (cnx, msg);
			oldvalue = *hancheGauche;

			 // quart tour gauche
		 }

	 }
	 else
	 {
		 // en face
		if (savMov[(savPos - 1) % 12] == faceCam)
			return;
		addCombinaison(faceCam);
		msg[0] = '6';
		OutputDebugString(L"faceCam\n");
		setMessageUDP (cnx, msg);
		oldvalue = *hancheGauche;

	 }
		 

}


void hanche(struct cnx *cnx, struct pos *pos)
{
	static struct pos oldvalue = { 0 };
	static struct pos oldvalue2 = { 0 };
	static struct pos oldvalueZ = { 0 };
	static enum mouvement currentX = hancheDroite;
	static enum mouvement currentZ = hancheAvant;
	char msg[3];
	msg[1] = '0';
	msg[2] = '\0';
				
	if (oldvalue.z == 0)
	{
		oldvalue = *pos;
		oldvalueZ = *pos;
		oldvalue2 = *pos;
		return;
	}


	if (pos->x - oldvalue2.x > -0.01f) // process to right
	{
		if (!(currentX == hancheDroite))
		{
			currentX = hancheDroite;
			
			wchar_t test[255] = { '\0' };
			swprintf(test, L"hancheDroite timing %i : %i : %i\n", HancheMininalDuration,pos->time - oldvalue.time, HancheMaximalDuration);
			OutputDebugString(test);
			swprintf(test, L"hancheDroite position %f : %f : %f\n", HancheMinimalLengthH,std::abs(pos->x - oldvalue.x), HancheMaximalLengthH);
			OutputDebugString(test);
	
			if ((pos->time - oldvalue.time > HancheMininalDuration) 
				&& (pos->time - oldvalue.time < HancheMaximalDuration)
				&& (std::abs(pos->x - oldvalue.x) > HancheMinimalLengthH)
				&& (std::abs(pos->x - oldvalue.x) < HancheMaximalLengthH))
			{
					msg[0] = '8';
					OutputDebugString(L"HancheGauche\n");
					addCombinaison(hancheGauche);
					setMessageUDP (cnx, msg);
			}
			oldvalue = *pos;
		}
	}
	else// if (pos->x - oldvalue.x < 0.01f)// process to left
	{
		if (!(currentX == hancheGauche))
		{
			wchar_t test[255] = { '\0' };
			swprintf(test, L"hancheGauche timing %i : %i : %i\n", HancheMininalDuration,pos->time - oldvalue.time, HancheMaximalDuration);
			OutputDebugString(test);
			swprintf(test, L"hancheGauche position %f : %f : %f\n", HancheMinimalLengthH,std::abs(pos->x - oldvalue.x), HancheMaximalLengthH);
			OutputDebugString(test);
	
			currentX = hancheGauche;
			if ((pos->time - oldvalue.time > HancheMininalDuration) 
				&& (pos->time - oldvalue.time < HancheMaximalDuration)
				&& (std::abs(pos->x - oldvalue.x) > HancheMinimalLengthH)
				&& (std::abs(pos->x - oldvalue.x) < HancheMaximalLengthH))
			{
					msg[0] = '7';
					OutputDebugString(L"HancheDroite\n");
					addCombinaison(hancheDroite);
					setMessageUDP (cnx, msg);
			}
			oldvalue = *pos;
		}
	}
    
	
	if (pos->z - oldvalue2.z < 0.01f) // process avant
	{
		

		if (!(currentZ == hancheAvant))
		{
		
			wchar_t test[255] = { '\0' };
			swprintf(test, L"hancheAvant timing %i : %i : %i\n", HancheMininalDuration,pos->time - oldvalueZ.time, HancheMaximalDuration);
			OutputDebugString(test);
			swprintf(test, L"hancheAvant position %f : %f : %f\n", HancheMinimalLengthZ,std::abs(pos->z - oldvalueZ.z), HancheMaximalLengthZ);
			OutputDebugString(test);

			currentZ = hancheAvant;
		
			if ((pos->time - oldvalueZ.time > HancheMininalDuration) 
				&& (pos->time - oldvalueZ.time < HancheMaximalDuration)
				&& (std::abs(pos->z - oldvalueZ.z) > HancheMinimalLengthZ)
				&& (std::abs(pos->z - oldvalueZ.z) < HancheMaximalLengthZ))
			{
					msg[0] = 58;
					OutputDebugString(L"HancheArriere\n");
					addCombinaison(hancheApres);
					setMessageUDP (cnx, msg);
			}
			oldvalueZ = *pos;
		}
	}
	else// if (pos->z - oldvalueZ.z > -0.01f)// process recule
	{
		

		if (!(currentZ == hancheApres))
		{

			wchar_t test[255] = { '\0' };
			swprintf(test, L"hancheArriere timing %i : %i : %i\n", HancheMininalDuration,pos->time - oldvalueZ.time, HancheMaximalDuration);
			OutputDebugString(test);
			swprintf(test, L"hancheArriere position %f : %f : %f\n", HancheMinimalLengthZ,std::abs(pos->z - oldvalueZ.z), HancheMaximalLengthZ);
			OutputDebugString(test);
	
			currentZ = hancheApres;
			if ((pos->time - oldvalueZ.time > HancheMininalDuration) 
				&& (pos->time - oldvalueZ.time < HancheMaximalDuration)
				&& (std::abs(pos->z - oldvalueZ.z) > HancheMinimalLengthZ)
				&& (std::abs(pos->z - oldvalueZ.z) < HancheMaximalLengthZ))
			{
					msg[0] = '9';
					OutputDebugString(L"HancheAvant\n");
					addCombinaison(hancheApres);
					setMessageUDP (cnx, msg);
			}
			oldvalueZ = *pos;
		}
	}
	oldvalue2 = *pos;
    
}


// 0 au centre
	// 0.5 au plus haut
	// -0.5 au plus bas
	